----------------------------------LOADER------------------------------------

--loads the hardon collider module and adds it to the HC variable
HC = require 'hardoncollider'

function love.load()

	--creates a new collision detection instance setting on_collide as callback
    Collider = HC(100, on_collide)

	-- All sprites
	player_red = love.graphics.newImage("player_red.png")
	player_green = love.graphics.newImage("player_green.png")
	statusbar = love.graphics.newImage("statusbar.png")
	cursor = love.graphics.newImage("cursor.png")
	laser1 = love.graphics.newImage("laser1.png")
	laser2 = love.graphics.newImage("laser2.png")
	skull_green = love.graphics.newImage("skullgreen.png")
	skull_red = love.graphics.newImage("skullred.png")
	
	love.mouse.setVisible(false)
	
	--Player Variables
	player_pos_x = 350
	player_pos_y = 200
	movement_speed = 5
	health = 100
	energy = 100
	
	-- Red Skull enemy variables
	skull_red_pos_x	= 50
	skull_red_pos_y = 50
	skull_red_direction_x = 1 	--| 1 == right | -1 = left | 
	skull_red_direction_y = 1 	--| 1 == down | -1 = up | 
	skull_red_movementspeed = 3
	skull_red_health = 80
	
	--colliders
	player_collider = Collider:addRectangle( player_pos_x, player_pos_y, 50, 85)
	enemy_collider = Collider:addRectangle( skull_red_pos_x, skull_red_pos_y, 80, 80)
	cursor_collider = Collider:addRectangle(0,0,10,10)

end

----------------------------------UPDATER------------------------------------

function love.update(dt)

	-- Player + player_collider Controls
	if love.keyboard.isDown("w") then
		player_pos_y = player_pos_y - movement_speed
	end
	
	if love.keyboard.isDown("s") then
		player_pos_y = player_pos_y + movement_speed
	end
	
	if love.keyboard.isDown("a") then
		player_pos_x = player_pos_x - movement_speed
	end
	
	if love.keyboard.isDown("d") then
		player_pos_x = player_pos_x + movement_speed
	end
	
	-- Player Boundaries
	if player_pos_x < 0 then
		player_pos_x = 0
	elseif player_pos_x > 750 then
		player_pos_x = 750
	end
	
	if player_pos_y < 0 then
		player_pos_y = 0
	elseif player_pos_y > 415 then
		player_pos_y = 415
	end
	
	--energy management
	if love.mouse.isDown("l") and energy > 1 or love.mouse.isDown("r") and energy > 1 then
		energy = energy - 1
	elseif energy < 100 then
		energy = energy + 0.2
	end
	
	--enemy movement
	skull_red_pos_x = skull_red_pos_x + skull_red_direction_x * skull_red_movementspeed
	skull_red_pos_y = skull_red_pos_y + skull_red_direction_y * skull_red_movementspeed
	
	--enemy boundaries
		if skull_red_pos_x < 0 then
		skull_red_pos_x = 0
		skull_red_direction_x = skull_red_direction_x * -1
	elseif skull_red_pos_x > 720 then
		skull_red_pos_x = 720
		skull_red_direction_x = skull_red_direction_x * -1
	end
	
	if skull_red_pos_y < 0 then
		skull_red_pos_y = 0
		skull_red_direction_y = skull_red_direction_y * -1
	elseif skull_red_pos_y > 420 then
		skull_red_pos_y = 420
		skull_red_direction_y = skull_red_direction_y * -1
	end

	--Will check for collision and run the callback functions
	Collider:update(dt)
	player_collider:moveTo( player_pos_x + 25, player_pos_y + 40)
	enemy_collider:moveTo( skull_red_pos_x + 40, skull_red_pos_y + 40 )
	cursor_collider:moveTo( love.mouse.getX() + 5, love.mouse.getY() + 5)
	
	--Handle Collisions
	if player_collider:collidesWith(enemy_collider) then
		health = health - 0.5
	end
	
	if love.mouse.isDown("l") and cursor_collider:collidesWith(enemy_collider) then
		skull_red_health = skull_red_health - 1
	end
	
end

-----------------------------------RENDERER---------------------------------------------

function love.draw()
	--draw enemy + lifebar
	love.graphics.setLineWidth(5)
	love.graphics.draw(skull_red, skull_red_pos_x, skull_red_pos_y)
	love.graphics.setColor(50,0,0,255)
	love.graphics.line( skull_red_pos_x , skull_red_pos_y -15,  skull_red_pos_x +80 , skull_red_pos_y - 15 )
	love.graphics.setColor(225,0,0,255)
	love.graphics.line( skull_red_pos_x , skull_red_pos_y -15,  skull_red_pos_x + skull_red_health , skull_red_pos_y - 15 )
	
	--laser and player animation
	love.graphics.setLineWidth(5)
	
	love.graphics.setColor(255,255,255,255)
	
	if love.mouse.isDown("l") then
		love.graphics.draw(player_red, player_pos_x, player_pos_y)
		love.graphics.setColor(255,0,0,255)
		if love.mouse.getY() < 500 then
			love.graphics.line( player_pos_x +18, player_pos_y +18,  love.mouse.getX(), love.mouse.getY() )
			love.graphics.setColor(255,255,255,255)
			love.graphics.draw( laser1, love.mouse.getX() -20, love.mouse.getY() -20 )
		else 
			love.graphics.line( player_pos_x +18, player_pos_y +18,  love.mouse.getX(), 500)
			love.graphics.setColor(255,255,255,255)
			love.graphics.draw( laser1, love.mouse.getX() -20, 480)
		end

	elseif love.mouse.isDown("r") then
		love.graphics.draw(player_green, player_pos_x, player_pos_y)
		love.graphics.setColor(0,255,0,255)
		if love.mouse.getY() < 500 then
			love.graphics.line( player_pos_x +18, player_pos_y +18,  love.mouse.getX(), love.mouse.getY() )
			love.graphics.setColor(255,255,255,255)
			love.graphics.draw( laser2, love.mouse.getX() -20, love.mouse.getY() -20 )
		else 
			love.graphics.line( player_pos_x +18, player_pos_y +18,  love.mouse.getX(), 500)
			love.graphics.setColor(255,255,255,255)
			love.graphics.draw( laser2, love.mouse.getX() -20, 480)
		end
	else
		love.graphics.draw(player_red, player_pos_x, player_pos_y)
		love.graphics.draw(cursor, love.mouse.getX() -15, love.mouse.getY() -15 )
	end
	
	love.graphics.draw(statusbar, 0, 500)
	love.graphics.setBackgroundColor( 43,21,46 )
	
	--life and energy bar
	--life bar
	love.graphics.setLineWidth(10)
	love.graphics.setColor(50,0,0,255)
	love.graphics.line( 50, 530, 450, 530 )
	love.graphics.setColor(225,0,0,255)
	love.graphics.line( 50, 530, health * 4 + 50, 530 )
	
	--energy bar
	love.graphics.setLineWidth(5)
	love.graphics.setColor(93,90,0,255)
	love.graphics.line( 50, 560, 450, 560 )
	love.graphics.setColor(255,222,0,255)
	love.graphics.line( 50, 560, energy * 4 + 50, 560 )
	
	--Set color back to default
	love.graphics.setColor(255,255,255,255)
	
	--enemy_collider:draw()
	--player_collider:draw()
	
end